## keepassxc 2.2.0

=== CMakeLists.txt ===
#  Copyright (C) 2010 Felix Geyer <debfx@fobos.de>
#  Copyright (C) 2017 KeePassXC Team <team@keepassxc.org>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo Debug DebugFull Profile MinSizeRel."
      FORCE)
endif()

project(KeePassXC)

cmake_minimum_required(VERSION 2.8.12)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Support Visual Studio Code
include(CMakeToolsHelpers OPTIONAL)

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCXXSourceCompiles)

option(WITH_TESTS "Enable building of unit tests" ON)
option(WITH_GUI_TESTS "Enable building of GUI tests" OFF)
option(WITH_DEV_BUILD "Use only for development. Disables/warns about deprecated methods." OFF)
option(WITH_ASAN "Enable address sanitizer checks (Linux only)" OFF)
option(WITH_COVERAGE "Use to build with coverage tests (GCC only)." OFF)
option(WITH_APP_BUNDLE "Enable Application Bundle for OS X" ON)

option(WITH_XC_AUTOTYPE "Include Auto-Type." ON)
option(WITH_XC_HTTP "Include KeePassHTTP and Custom Icon Downloads." OFF)
option(WITH_XC_YUBIKEY "Include YubiKey support." OFF)

# Process ui files automatically from source files
set(CMAKE_AUTOUIC ON)

set(KEEPASSXC_VERSION_MAJOR "2")
set(KEEPASSXC_VERSION_MINOR "2")
set(KEEPASSXC_VERSION_PATCH "0")
set(KEEPASSXC_VERSION "${KEEPASSXC_VERSION_MAJOR}.${KEEPASSXC_VERSION_MINOR}.${KEEPASSXC_VERSION_PATCH}")

if("${CMAKE_C_COMPILER}" MATCHES "clang$" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANG 1)
endif()

if("${CMAKE_CXX_COMPILER}" MATCHES "clang(\\+\\+)?$" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANGXX 1)
endif()

macro(add_gcc_compiler_cxxflags FLAGS)
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}")
  endif()
endmacro(add_gcc_compiler_cxxflags)

macro(add_gcc_compiler_cflags FLAGS)
  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS}")
  endif()
endmacro(add_gcc_compiler_cflags)

macro(add_gcc_compiler_flags FLAGS)
  add_gcc_compiler_cxxflags("${FLAGS}")
  add_gcc_compiler_cflags("${FLAGS}")
endmacro(add_gcc_compiler_flags)

add_definitions(-DQT_NO_EXCEPTIONS -DQT_STRICT_ITERATORS -DQT_NO_CAST_TO_ASCII)

if(WITH_APP_BUNDLE)
  add_definitions(-DWITH_APP_BUNDLE)
endif()

add_gcc_compiler_flags("-fno-common")
add_gcc_compiler_flags("-Wall -Wextra -Wundef -Wpointer-arith -Wno-long-long")
add_gcc_compiler_flags("-Wformat=2 -Wmissing-format-attribute")
add_gcc_compiler_flags("-fvisibility=hidden")
add_gcc_compiler_cxxflags("-fvisibility-inlines-hidden")

if((CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.8.999) OR CMAKE_COMPILER_IS_CLANGXX)
    add_gcc_compiler_flags("-fstack-protector-strong")
else()
    add_gcc_compiler_flags("-fstack-protector --param=ssp-buffer-size=4")
endif()

add_gcc_compiler_cxxflags("-fno-exceptions -fno-rtti")
add_gcc_compiler_cxxflags("-Wnon-virtual-dtor -Wold-style-cast -Woverloaded-virtual")
add_gcc_compiler_cflags("-Wchar-subscripts -Wwrite-strings")
if(WITH_ASAN)
  if(NOT CMAKE_SYSTEM_NAME STREQUAL "Linux")
      message(FATAL_ERROR "WITH_ASAN is only supported on Linux at the moment.")
  endif()

  add_gcc_compiler_flags("-fsanitize=address -DWITH_ASAN")

  if(NOT (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9))
    add_gcc_compiler_flags("-fsanitize=leak -DWITH_LSAN")
  endif()
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
if (CMAKE_BUILD_TYPE_LOWER MATCHES "(release|relwithdebinfo|minsizerel)")
  add_gcc_compiler_flags("-D_FORTIFY_SOURCE=2")
endif()

check_c_compiler_flag("-Werror=format-security -Werror=implicit-function-declaration" WERROR_C_AVAILABLE)
check_cxx_compiler_flag("-Werror=format-security" WERROR_CXX_AVAILABLE)
if(WERROR_C_AVAILABLE AND WERROR_CXX_AVAILABLE)
  add_gcc_compiler_flags("-Werror=format-security")
  add_gcc_compiler_cflags("-Werror=implicit-function-declaration")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")

  if(WITH_COVERAGE)
    # Include code coverage, use with -DCMAKE_BUILD_TYPE=Coverage
    include(CodeCoverage)
    setup_target_for_coverage(kp_coverage "make test" coverage)
  endif()
endif()

if(CMAKE_COMPILER_IS_GNUCC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-align")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  if (CMAKE_COMPILER_IS_CLANGXX)
      add_gcc_compiler_flags("-Qunused-arguments")
  endif()
  add_gcc_compiler_flags("-pie -fPIE")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-add-needed -Wl,--as-needed -Wl,--no-undefined")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,-z,now")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-add-needed -Wl,--as-needed")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,relro,-z,now")
endif()

add_gcc_compiler_cxxflags("-std=c++11")

if(APPLE)
  add_gcc_compiler_cxxflags("-stdlib=libc++")
endif()

add_gcc_compiler_cflags("-ansi")

if(WITH_DEV_BUILD)
  add_definitions(-DQT_DEPRECATED_WARNINGS -DGCRYPT_NO_DEPRECATED)
endif()

if(MINGW)
  set(CMAKE_RC_COMPILER_INIT windres)
  enable_language(RC)
  set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  if(NOT (CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo"))
    # Enable DEP and ASLR
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--nxcompat -Wl,--dynamicbase")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--nxcompat -Wl,--dynamicbase")
  endif()
endif()

if(APPLE AND WITH_APP_BUNDLE OR MINGW)
  set(PROGNAME KeePassXC)
else()
  set(PROGNAME keepassxc)
endif()

if(APPLE AND WITH_APP_BUNDLE AND "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local")
  set(CMAKE_INSTALL_PREFIX "/Applications")
endif()

if(MINGW)
  set(CLI_INSTALL_DIR    ".")
  set(BIN_INSTALL_DIR    ".")
  set(PLUGIN_INSTALL_DIR ".")
  set(DATA_INSTALL_DIR   "share")
elseif(APPLE AND WITH_APP_BUNDLE)
  set(CLI_INSTALL_DIR    "/usr/local/bin")
  set(BIN_INSTALL_DIR    ".")
  set(PLUGIN_INSTALL_DIR "${PROGNAME}.app/Contents/PlugIns")
  set(DATA_INSTALL_DIR   "${PROGNAME}.app/Contents/Resources")
else()
  include(GNUInstallDirs)

  set(CLI_INSTALL_DIR    "${CMAKE_INSTALL_BINDIR}")
  set(BIN_INSTALL_DIR    "${CMAKE_INSTALL_BINDIR}")
  set(PLUGIN_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/keepassxc")
  set(DATA_INSTALL_DIR   "${CMAKE_INSTALL_DATADIR}/keepassxc")
endif()

if(WITH_TESTS)
  enable_testing()
endif(WITH_TESTS)

find_package(Qt5Core          5.2 REQUIRED)
find_package(Qt5Network       5.2 REQUIRED)
find_package(Qt5Concurrent    5.2 REQUIRED)
find_package(Qt5Widgets       5.2 REQUIRED)
find_package(Qt5Test          5.2 REQUIRED)
find_package(Qt5LinguistTools 5.2 REQUIRED)
find_package(Qt5Network       5.2 REQUIRED)
if (UNIX AND NOT APPLE)
    find_package(Qt5DBus 5.2 REQUIRED)
endif()
set(CMAKE_AUTOMOC ON)

# Debian sets the the build type to None for package builds.
# Make sure we don't enable asserts there.
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_NONE QT_NO_DEBUG)

find_package(LibGPGError REQUIRED)

find_package(Gcrypt 1.6.0 REQUIRED)

find_package(ZLIB REQUIRED)

check_cxx_source_compiles("
  #include <zlib.h>

  #if !defined(ZLIB_VERNUM) || (ZLIB_VERNUM < 0x1200)
      #error zlib 1.2.x or higher is required to use the gzip format
  #endif

  int main() { return 0; }" ZLIB_SUPPORTS_GZIP)

if(NOT ZLIB_SUPPORTS_GZIP)
  message(FATAL_ERROR "zlib 1.2.x or higher is required to use the gzip format")
endif()

# Optional
if(WITH_XC_YUBIKEY)
  find_package(YubiKey REQUIRED)

  include_directories(SYSTEM ${YUBIKEY_INCLUDE_DIRS})
endif()

if(UNIX)
  check_cxx_source_compiles("#include <sys/prctl.h>
    int main() { prctl(PR_SET_DUMPABLE, 0); return 0; }"
    HAVE_PR_SET_DUMPABLE)

  check_cxx_source_compiles("#include <sys/resource.h>
    int main() {
      struct rlimit limit;
      limit.rlim_cur = 0;
      limit.rlim_max = 0;
      setrlimit(RLIMIT_CORE, &limit);
      return 0;
    }" HAVE_RLIMIT_CORE)

  if(APPLE)
    check_cxx_source_compiles("#include <sys/types.h>
      #include <sys/ptrace.h>
      int main() { ptrace(PT_DENY_ATTACH, 0, 0, 0); return 0; }"
      HAVE_PT_DENY_ATTACH)
  endif()
endif()

include_directories(SYSTEM ${GCRYPT_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR})

include(FeatureSummary)

add_subdirectory(src)
add_subdirectory(share)
if(WITH_TESTS)
  add_subdirectory(tests)
endif(WITH_TESTS)

if(PRINT_SUMMARY)
  # This will print ENABLED, REQUIRED and DISABLED
  feature_summary(WHAT ALL)
else()
  # This will only print ENABLED and DISABLED feature
  feature_summary(WHAT ENABLED_FEATURES DESCRIPTION "Enabled features:")
  feature_summary(WHAT DISABLED_FEATURES DESCRIPTION "Disabled features:")
endif()

=== share/CMakeLists.txt ===
#  Copyright (C) 2011 Felix Geyer <debfx@fobos.de>
#  Copyright (C) 2017 KeePassXC Team <team@keepassxc.org>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(translations)

file(GLOB wordlists_files "wordlists/*.wordlist")
install(FILES ${wordlists_files} DESTINATION ${DATA_INSTALL_DIR}/wordlists)

file(GLOB DATABASE_ICONS icons/database/*.png)

install(FILES ${DATABASE_ICONS} DESTINATION ${DATA_INSTALL_DIR}/icons/database)

if(UNIX AND NOT APPLE)
    install(DIRECTORY icons/application/ DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor
            FILES_MATCHING PATTERN "keepassx*.png" PATTERN "keepassx*.svgz"
            PATTERN "status" EXCLUDE PATTERN "actions" EXCLUDE PATTERN "categories" EXCLUDE)
    install(DIRECTORY icons/application/ DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor
            FILES_MATCHING PATTERN "application-x-keepassxc.png" PATTERN "application-x-keepassxc.svgz"
            PATTERN "status" EXCLUDE PATTERN "actions" EXCLUDE PATTERN "categories" EXCLUDE)
    install(FILES linux/keepassxc.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES linux/keepassxc.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)
endif(UNIX AND NOT APPLE)

if(APPLE)
  install(FILES macosx/keepassxc.icns DESTINATION ${DATA_INSTALL_DIR})
endif()

install(DIRECTORY icons/application/ DESTINATION ${DATA_INSTALL_DIR}/icons/application
        FILES_MATCHING PATTERN "*.png" PATTERN "*.svgz")

add_custom_target(icons
                  # SVGZ to PNGs for KeePassXC
                  COMMAND inkscape -z -w 16 -h 16
                    icons/application/scalable/apps/keepassxc.svgz -e icons/application/16x16/apps/keepassxc.png
                  COMMAND inkscape -z -w  24 -h 24
                    icons/application/scalable/apps/keepassxc.svgz -e icons/application/24x24/apps/keepassxc.png
                  COMMAND inkscape -z -w  32 -h 32
                    icons/application/scalable/apps/keepassxc.svgz -e icons/application/32x32/apps/keepassxc.png
                  COMMAND inkscape -z -w 48 -h 48
                    icons/application/scalable/apps/keepassxc.svgz -e icons/application/48x48/apps/keepassxc.png
                  COMMAND inkscape -z -w 64 -h 64
                    icons/application/scalable/apps/keepassxc.svgz -e icons/application/64x64/apps/keepassxc.png
                  COMMAND inkscape -z -w 128 -h 128
                    icons/application/scalable/apps/keepassxc.svgz -e icons/application/128x128/apps/keepassxc.png
                  COMMAND inkscape -z -w 256 -h 256
                    icons/application/scalable/apps/keepassxc.svgz -e icons/application/256x256/apps/keepassxc.png

                  # SVGZ to PNGs for KeePassXC
                  COMMAND inkscape -z -w 16 -h 16
                    icons/application/scalable/apps/keepassxc-dark.svgz -e icons/application/16x16/apps/keepassxc-dark.png
                  COMMAND inkscape -z -w  24 -h 24
                    icons/application/scalable/apps/keepassxc-dark.svgz -e icons/application/24x24/apps/keepassxc-dark.png
                  COMMAND inkscape -z -w  32 -h 32
                    icons/application/scalable/apps/keepassxc-dark.svgz -e icons/application/32x32/apps/keepassxc-dark.png
                  COMMAND inkscape -z -w 48 -h 48
                    icons/application/scalable/apps/keepassxc-dark.svgz -e icons/application/48x48/apps/keepassxc-dark.png
                  COMMAND inkscape -z -w 64 -h 64
                    icons/application/scalable/apps/keepassxc-dark.svgz -e icons/application/64x64/apps/keepassxc-dark.png
                  COMMAND inkscape -z -w 128 -h 128
                    icons/application/scalable/apps/keepassxc-dark.svgz -e icons/application/128x128/apps/keepassxc-dark.png
                  COMMAND inkscape -z -w 256 -h 256
                    icons/application/scalable/apps/keepassxc-dark.svgz -e icons/application/256x256/apps/keepassxc-dark.png

                  # SVGZ to PNGs for KeePassXC
                  COMMAND inkscape -z -w 16 -h 16
                    icons/application/scalable/apps/keepassxc-locked.svgz -e icons/application/16x16/apps/keepassxc-locked.png
                  COMMAND inkscape -z -w  24 -h 24
                    icons/application/scalable/apps/keepassxc-locked.svgz -e icons/application/24x24/apps/keepassxc-locked.png
                  COMMAND inkscape -z -w  32 -h 32
                    icons/application/scalable/apps/keepassxc-locked.svgz -e icons/application/32x32/apps/keepassxc-locked.png
                  COMMAND inkscape -z -w 48 -h 48
                    icons/application/scalable/apps/keepassxc-locked.svgz -e icons/application/48x48/apps/keepassxc-locked.png
                  COMMAND inkscape -z -w 64 -h 64
                    icons/application/scalable/apps/keepassxc-locked.svgz -e icons/application/64x64/apps/keepassxc-locked.png
                  COMMAND inkscape -z -w 128 -h 128
                    icons/application/scalable/apps/keepassxc-locked.svgz -e icons/application/128x128/apps/keepassxc-locked.png
                  COMMAND inkscape -z -w 256 -h 256
                    icons/application/scalable/apps/keepassxc-locked.svgz -e icons/application/256x256/apps/keepassxc-locked.png

                  # SVGZ to PNGs for KeePassXC
                  COMMAND inkscape -z -w 16 -h 16
                    icons/application/scalable/apps/keepassxc-unlocked.svgz -e icons/application/16x16/apps/keepassxc-unlocked.png
                  COMMAND inkscape -z -w  24 -h 24
                    icons/application/scalable/apps/keepassxc-unlocked.svgz -e icons/application/24x24/apps/keepassxc-unlocked.png
                  COMMAND inkscape -z -w  32 -h 32
                    icons/application/scalable/apps/keepassxc-unlocked.svgz -e icons/application/32x32/apps/keepassxc-unlocked.png
                  COMMAND inkscape -z -w 48 -h 48
                    icons/application/scalable/apps/keepassxc-unlocked.svgz -e icons/application/48x48/apps/keepassxc-unlocked.png
                  COMMAND inkscape -z -w 64 -h 64
                    icons/application/scalable/apps/keepassxc-unlocked.svgz -e icons/application/64x64/apps/keepassxc-unlocked.png
                  COMMAND inkscape -z -w 128 -h 128
                    icons/application/scalable/apps/keepassxc-unlocked.svgz -e icons/application/128x128/apps/keepassxc-unlocked.png
                  COMMAND inkscape -z -w 256 -h 256
                    icons/application/scalable/apps/keepassxc-unlocked.svgz -e icons/application/256x256/apps/keepassxc-unlocked.png

                  # SVGZ to PNGs for KeePassXC MIME-Type
                  COMMAND inkscape -z -w 16 -h 16
                    icons/application/scalable/mimetypes/application-x-keepassxc.svgz -e icons/application/16x16/mimetypes/application-x-keepassxc.png
                  COMMAND inkscape -z -w 22 -h 22
                    icons/application/scalable/mimetypes/application-x-keepassxc.svgz -e icons/application/22x22/mimetypes/application-x-keepassxc.png
                  COMMAND inkscape -z -w 32 -h 32
                    icons/application/scalable/mimetypes/application-x-keepassxc.svgz -e icons/application/32x32/mimetypes/application-x-keepassxc.png
                  COMMAND inkscape -z -w 64 -h 64
                    icons/application/scalable/mimetypes/application-x-keepassxc.svgz -e icons/application/64x64/mimetypes/application-x-keepassxc.png
                  COMMAND inkscape -z -w 128 -h 128
                    icons/application/scalable/mimetypes/application-x-keepassxc.svgz -e icons/application/128x128/mimetypes/application-x-keepassxc.png

                  # ICNS for MacOS
                  COMMAND png2icns macosx/keepassxc.icns
                    icons/application/16x16/apps/keepassxc.png
                    icons/application/32x32/apps/keepassxc.png
                    icons/application/48x48/apps/keepassxc.png
                    icons/application/128x128/apps/keepassxc.png
                    icons/application/256x256/apps/keepassxc.png

                  # ICO for Windows
                  COMMAND icotool -c -o windows/keepassxc.ico
                    icons/application/16x16/apps/keepassxc.png
                    icons/application/24x24/apps/keepassxc.png
                    icons/application/32x32/apps/keepassxc.png
                    icons/application/48x48/apps/keepassxc.png
                    icons/application/64x64/apps/keepassxc.png
                    icons/application/128x128/apps/keepassxc.png
                    icons/application/256x256/apps/keepassxc.png
                  VERBATIM
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== src/CMakeLists.txt ===
#  Copyright (C) 2010 Felix Geyer <debfx@fobos.de>
#  Copyright (C) 2017 KeePassXC Team <team@keepassxc.org>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

configure_file(config-keepassx.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-keepassx.h)

include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_HEAD)
git_describe(GIT_DESCRIBE --long)

if (NOT GIT_HEAD OR NOT GIT_DESCRIBE)
    set(GIT_HEAD "")
    set(GIT_DESCRIBE "")
endif()

configure_file(version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/version.h @ONLY)

set(keepassx_SOURCES
    core/AutoTypeAssociations.cpp
    core/Config.cpp
    core/CsvParser.cpp
    core/Database.cpp
    core/DatabaseIcons.cpp
    core/Endian.cpp
    core/Entry.cpp
    core/EntryAttachments.cpp
    core/EntryAttributes.cpp
    core/EntrySearcher.cpp
    core/FilePath.cpp
    core/Global.h
    core/Group.cpp
    core/InactivityTimer.cpp
    core/ListDeleter.h
    core/Metadata.cpp
    core/PasswordGenerator.cpp
    core/PassphraseGenerator.cpp
    core/SignalMultiplexer.cpp
    core/ScreenLockListener.cpp
    core/ScreenLockListener.h
    core/ScreenLockListenerPrivate.h
    core/ScreenLockListenerPrivate.cpp
    core/TimeDelta.cpp
    core/TimeInfo.cpp
    core/ToDbExporter.cpp
    core/Tools.cpp
    core/Translator.cpp
    core/Uuid.cpp
    cli/PasswordInput.cpp
    cli/PasswordInput.h
    crypto/Crypto.cpp
    crypto/CryptoHash.cpp
    crypto/Random.cpp
    crypto/SymmetricCipher.cpp
    crypto/SymmetricCipherBackend.h
    crypto/SymmetricCipherGcrypt.cpp
    format/CsvExporter.cpp
    format/KeePass1.h
    format/KeePass1Reader.cpp
    format/KeePass2.h
    format/KeePass2RandomStream.cpp
    format/KeePass2Reader.cpp
    format/KeePass2Repair.cpp
    format/KeePass2Writer.cpp
    format/KeePass2XmlReader.cpp
    format/KeePass2XmlWriter.cpp
    gui/AboutDialog.cpp
    gui/Application.cpp
    gui/CategoryListWidget.cpp
    gui/ChangeMasterKeyWidget.cpp
    gui/Clipboard.cpp
    gui/CloneDialog.cpp
    gui/DatabaseOpenWidget.cpp
    gui/DatabaseRepairWidget.cpp
    gui/DatabaseSettingsWidget.cpp
    gui/DatabaseTabWidget.cpp
    gui/DatabaseWidget.cpp
    gui/DatabaseWidgetStateSync.cpp
    gui/DialogyWidget.cpp
    gui/DragTabBar.cpp
    gui/EditWidget.cpp
    gui/EditWidgetIcons.cpp
    gui/EditWidgetProperties.cpp
    gui/FileDialog.cpp
    gui/IconModels.cpp
    gui/KeePass1OpenWidget.cpp
    gui/KMessageWidget.cpp
    gui/LineEdit.cpp
    gui/MainWindow.cpp
    gui/MessageBox.cpp
    gui/MessageWidget.cpp
    gui/PasswordEdit.cpp
    gui/PasswordGeneratorWidget.cpp
    gui/SettingsWidget.cpp
    gui/SearchWidget.cpp
    gui/SortFilterHideProxyModel.cpp
    gui/SetupTotpDialog.cpp
    gui/TotpDialog.cpp
    gui/UnlockDatabaseWidget.cpp
    gui/UnlockDatabaseDialog.cpp
    gui/WelcomeWidget.cpp
    gui/csvImport/CsvImportWidget.cpp
    gui/csvImport/CsvImportWizard.cpp
    gui/csvImport/CsvParserModel.cpp
    gui/entry/AutoTypeAssociationsModel.cpp
    gui/entry/EditEntryWidget.cpp
    gui/entry/EditEntryWidget_p.h
    gui/entry/EntryAttachmentsModel.cpp
    gui/entry/EntryAttributesModel.cpp
    gui/entry/EntryHistoryModel.cpp
    gui/entry/EntryModel.cpp
    gui/entry/EntryView.cpp
    gui/group/EditGroupWidget.cpp
    gui/group/GroupModel.cpp
    gui/group/GroupView.cpp
    keys/CompositeKey.cpp
    keys/CompositeKey_p.h
    keys/drivers/YubiKey.h
    keys/FileKey.cpp
    keys/Key.h
    keys/PasswordKey.cpp
    keys/YkChallengeResponseKey.cpp
    streams/HashedBlockStream.cpp
    streams/LayeredStream.cpp
    streams/qtiocompressor.cpp
    streams/StoreDataStream.cpp
    streams/SymmetricCipherStream.cpp
    totp/base32.h
    totp/base32.cpp
    totp/totp.h
    totp/totp.cpp
)
if(APPLE)
    set(keepassx_SOURCES ${keepassx_SOURCES}
        core/ScreenLockListenerMac.h
        core/ScreenLockListenerMac.cpp
        )
endif()
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(keepassx_SOURCES ${keepassx_SOURCES}
        core/ScreenLockListenerDBus.h
        core/ScreenLockListenerDBus.cpp
        )
endif()
if(MINGW)
    set(keepassx_SOURCES ${keepassx_SOURCES}
        core/ScreenLockListenerWin.h
        core/ScreenLockListenerWin.cpp
        )
endif()

set(keepassx_SOURCES_MAINEXE
    main.cpp
)

add_feature_info(AutoType WITH_XC_AUTOTYPE "Automatic password typing")
add_feature_info(KeePassHTTP WITH_XC_HTTP "Browser integration compatible with ChromeIPass and PassIFox")
add_feature_info(YubiKey WITH_XC_YUBIKEY "YubiKey HMAC-SHA1 challenge-response")

add_subdirectory(http)
if(WITH_XC_HTTP)
    set(keepasshttp_LIB keepasshttp qhttp Qt5::Network)
endif()

add_subdirectory(autotype)
add_subdirectory(cli)

set(autotype_SOURCES
    core/Tools.cpp
    autotype/AutoType.cpp
    autotype/AutoTypeAction.cpp
    autotype/AutoTypePlatformPlugin.h
    autotype/AutoTypeSelectDialog.cpp
    autotype/AutoTypeSelectView.cpp
    autotype/ShortcutWidget.cpp
    autotype/WildcardMatcher.cpp
    autotype/WindowSelectComboBox.cpp
    autotype/test/AutoTypeTestInterface.h
)

if(MINGW)
  set(keepassx_SOURCES_MAINEXE
      ${keepassx_SOURCES_MAINEXE}
      ${CMAKE_SOURCE_DIR}/share/windows/icon.rc)
endif()

if(WITH_XC_YUBIKEY)
  list(APPEND keepassx_SOURCES keys/drivers/YubiKey.cpp)
else()
  list(APPEND keepassx_SOURCES keys/drivers/YubiKeyStub.cpp)
endif()

add_library(zxcvbn STATIC zxcvbn/zxcvbn.cpp)
target_link_libraries(zxcvbn)

add_library(autotype STATIC ${autotype_SOURCES})
target_link_libraries(autotype Qt5::Core Qt5::Widgets)

set(autotype_LIB autotype)

add_library(keepassx_core STATIC ${keepassx_SOURCES})

set_target_properties(keepassx_core PROPERTIES COMPILE_DEFINITIONS KEEPASSX_BUILDING_CORE)
target_link_libraries(keepassx_core
                      ${keepasshttp_LIB}
                      ${autotype_LIB}
                      ${YUBIKEY_LIBRARIES}
                      zxcvbn
                      Qt5::Core
                      Qt5::Network
                      Qt5::Concurrent
                      Qt5::Widgets
                      ${GCRYPT_LIBRARIES}
                      ${GPGERROR_LIBRARIES}
                      ${ZLIB_LIBRARIES})

if(APPLE)
    target_link_libraries(keepassx_core "-framework Foundation")
endif()
if (UNIX AND NOT APPLE)
    target_link_libraries(keepassx_core Qt5::DBus)
endif()
if(MINGW)
    target_link_libraries(keepassx_core Wtsapi32.lib)
endif()

if(MINGW)
  include(GenerateProductVersion)
  generate_product_version(
    WIN32_ProductVersionFiles
    NAME "KeePassXC"
    COMPANY_NAME "KeePassXC Team"
    VERSION_MAJOR ${KEEPASSXC_VERSION_MAJOR}
    VERSION_MINOR ${KEEPASSXC_VERSION_MINOR}
    VERSION_PATCH ${KEEPASSXC_VERSION_PATCH}
  )
endif()

add_executable(${PROGNAME} WIN32 ${keepassx_SOURCES_MAINEXE} ${WIN32_ProductVersionFiles})
target_link_libraries(${PROGNAME} keepassx_core)

set_target_properties(${PROGNAME} PROPERTIES ENABLE_EXPORTS ON)

if(APPLE AND WITH_APP_BUNDLE)
  configure_file(${CMAKE_SOURCE_DIR}/share/macosx/Info.plist.cmake ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${PROGNAME} PROPERTIES
                        MACOSX_BUNDLE ON
                        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
endif()

install(TARGETS ${PROGNAME}
        BUNDLE DESTINATION . COMPONENT Runtime
        RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT Runtime)

if(APPLE AND WITH_APP_BUNDLE)
  if(QT_MAC_USE_COCOA AND EXISTS "${QT_LIBRARY_DIR}/Resources/qt_menu.nib")
    install(DIRECTORY "${QT_LIBRARY_DIR}/Resources/qt_menu.nib"
            DESTINATION "${DATA_INSTALL_DIR}")
  endif()

  set(CPACK_GENERATOR "DragNDrop")
  set(CPACK_DMG_FORMAT "UDBZ")
  set(CPACK_DMG_VOLUME_NAME "${PROGNAME}")
  set(CPACK_SYSTEM_NAME "OSX")
  set(CPACK_STRIP_FILES ON)
  set(CPACK_PACKAGE_FILE_NAME "${PROGNAME}-${KEEPASSXC_VERSION}")
  include(CPack)

  if(NOT DEFINED QT_BINARY_DIR)
    set(QT_BINARY_DIR "/usr/local/opt/qt5/bin" CACHE PATH "QT binary folder")
  endif()
  add_custom_command(TARGET ${PROGNAME}
                     POST_BUILD
                     COMMAND ${QT_BINARY_DIR}/macdeployqt ${PROGNAME}.app
                     WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src
                     COMMENT "Deploying app bundle")
endif()

if(MINGW)
  if(${CMAKE_SIZEOF_VOID_P} EQUAL "8")
    set(OUTPUT_FILE_POSTFIX "Win64")
  else()
    set(OUTPUT_FILE_POSTFIX "Win32")
  endif()

  set(CPACK_GENERATOR "ZIP;NSIS")
  set(CPACK_STRIP_FILES ON)
  set(CPACK_PACKAGE_FILE_NAME "${PROGNAME}-${KEEPASSXC_VERSION}-${OUTPUT_FILE_POSTFIX}")
  set(CPACK_PACKAGE_INSTALL_DIRECTORY ${PROGNAME})
  set(CPACK_PACKAGE_VERSION ${KEEPASSXC_VERSION})
  set(CPACK_PACKAGE_VENDOR "${PROGNAME} Team")
  string(REGEX REPLACE "/" "\\\\\\\\" CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}/share/windows/installer-header.bmp")
  set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE.GPL-2")
  set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL ON)
  set(CPACK_NSIS_MUI_ICON "${CMAKE_SOURCE_DIR}/share/windows/keepassxc.ico")
  set(CPACK_NSIS_MUI_UNIICON "${CPACK_NSIS_MUI_ICON}")
  set(CPACK_NSIS_INSTALLED_ICON_NAME "\\\\${PROGNAME}.exe")
  string(REGEX REPLACE "/" "\\\\\\\\" CPACK_NSIS_MUI_WELCOMEFINISHPAGE_BITMAP "${CMAKE_SOURCE_DIR}/share/windows/installer-wizard.bmp")
  set(CPACK_NSIS_MUI_UNWELCOMEFINISHPAGE_BITMAP "${CPACK_NSIS_MUI_WELCOMEFINISHPAGE_BITMAP}")
  set(CPACK_NSIS_CREATE_ICONS_EXTRA "CreateShortCut '$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\${PROGNAME}.lnk' '$INSTDIR\\\\${PROGNAME}.exe'")
  set(CPACK_NSIS_DELETE_ICONS_EXTRA "Delete '$SMPROGRAMS\\\\$START_MENU\\\\${PROGNAME}.lnk'")
  set(CPACK_NSIS_URL_INFO_ABOUT "https://keepassxc.org")
  set(CPACK_NSIS_DISPLAY_NAME ${PROGNAME})
  set(CPACK_NSIS_PACKAGE_NAME "${PROGNAME} v${KEEPASSXC_VERSION}")
  set(CPACK_NSIS_MUI_FINISHPAGE_RUN "../${PROGNAME}.exe")
  include(CPack)

  install(CODE "
  set(gp_tool \"objdump\")
  " COMPONENT Runtime)

  include(DeployQt4)
  install_qt4_executable(${PROGNAME}.exe)
  add_custom_command(TARGET ${PROGNAME} POST_BUILD
                     COMMAND ${CMAKE_COMMAND} -E copy_if_different ${Qt5Core_DIR}/../../../share/qt5/plugins/platforms/qwindows$<$<CONFIG:Debug>:d>.dll
                     $<TARGET_FILE_DIR:${PROGNAME}>)
  install(FILES $<TARGET_FILE_DIR:${PROGNAME}>/qwindows$<$<CONFIG:Debug>:d>.dll DESTINATION "platforms")
endif()

=== src/cli/CMakeLists.txt ===
#  Copyright (C) 2017 KeePassXC Team
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(cli_SOURCES
    Clip.cpp
    Clip.h
    EntropyMeter.cpp
    EntropyMeter.h
    Extract.cpp
    Extract.h
    List.cpp
    List.h
    Merge.cpp
    Merge.h
    Show.cpp
    Show.h)

add_library(cli STATIC ${cli_SOURCES})
target_link_libraries(cli Qt5::Core Qt5::Widgets)

add_executable(keepassxc-cli keepassxc-cli.cpp)
target_link_libraries(keepassxc-cli
                      cli
                      keepassx_core
                      Qt5::Core
                      ${GCRYPT_LIBRARIES}
                      ${GPGERROR_LIBRARIES}
                      ${ZLIB_LIBRARIES}
                      zxcvbn)

install(TARGETS keepassxc-cli
        BUNDLE DESTINATION . COMPONENT Runtime
        RUNTIME DESTINATION ${CLI_INSTALL_DIR} COMPONENT Runtime)

=== debian/changelog ===
keepassxc (2.2.0-1mx17+1) mx; urgency=medium

  * Rebuild for MX-17.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 13 Sep 2017 15:30:44 -0700

keepassxc (2.2.0-1mx15+1) mx; urgency=medium

  * Rebuild for MX-15.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 26 Jun 2017 12:42:02 -0700

keepassxc (2.2.0-1) unstable; urgency=low

  * New upstream release
  * Enabled YubiKey HMAC-SHA1 authentication support
  * Added manpage for the keepassxc-cli program

 -- Manolis Agkopian <m.agkopian@gmail.com>  Mon, 26 Jun 2017 10:08:19 +0300

keepassxc (2.1.4-1) unstable; urgency=low

  * New upstream release

 -- Manolis Agkopian <m.agkopian@gmail.com>  Mon, 10 Apr 2017 11:32:25 +0300

keepassxc (2.1.3-1) unstable; urgency=low

  * New upstream release

 -- Manolis Agkopian <m.agkopian@gmail.com>  Fri, 03 Mar 2017 14:03:52 +0200

keepassxc (2.1.2-1) unstable; urgency=low

  * New upstream release

 -- Manolis Agkopian <m.agkopian@gmail.com>  Sat, 18 Feb 2017 15:42:40 +0200

keepassxc (2.1.1-1) unstable; urgency=low

  * New upstream release

 -- Manolis Agkopian <m.agkopian@gmail.com>  Sun, 12 Feb 2017 23:04:39 +0200

keepassxc (2.1.0-1) unstable; urgency=low

  * Initial release

 -- Manolis Agkopian <m.agkopian@gmail.com>  Tue, 24 Jan 2017 19:21:55 +0200

=== debian/control ===
Source: keepassxc
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Manolis Agkopian <m.agkopian@gmail.com>
Build-Depends: debhelper (>= 9),
               cmake (>= 3.1),
               qtbase5-dev (>= 5.2),
               qttools5-dev (>= 5.2),
               qttools5-dev-tools (>= 5.2),
               libgcrypt20-dev (>= 1.6),
               zlib1g-dev,
               libmicrohttpd-dev,
               libxi-dev,
               libxtst-dev,
               libqt5x11extras5-dev,
               libyubikey-dev,
               libykpers-1-dev
Standards-Version: 3.9.8
Homepage: https://keepassxc.org/
Vcs-Git: https://github.com/keepassxreboot/keepassxc.git
Vcs-Browser: https://github.com/keepassxreboot/keepassxc

Package: keepassxc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cross Platform Password Manager
 KeePassXC is a free/open-source password manager or safe which helps you
 to manage your passwords in a secure way. You can put all your
 passwords in one database, which is locked with one master key or a
 key-disk. So you only have to remember one single master password or
 insert the key-disk to unlock the whole database. The databases are
 encrypted using the algorithms AES or Twofish.
 .
 Additionally, KeePassXC provides keepasshttp support for use with PassIFox 
 for Mozilla Firefox and chromeIPass for Google Chrome.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export LC_ALL = C.UTF-8

# main packaging script based on dh7 syntax
%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DWITH_TESTS=ON -DWITH_GUI_TESTS=ON -DWITH_XC_AUTOTYPE=ON -DWITH_XC_HTTP=ON -DWITH_XC_YUBIKEY=ON

override_dh_auto_test:
	dh_auto_test -- \
	ARGS+="-E testgui"
#	xvfb-run -a --server-args="-screen 0 800x600x24" dh_auto_test -- \
#	ARGS+="-R testgui"
	
override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/keepassxc

=== debian/watch ===
# See uscan(1) for format
# Compulsory line, this is a version 3 file
version=3

opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/keepassxc-$1\.tar\.gz/,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/" \
  https://github.com/keepassxreboot/keepassxc/releases .*/v?(\d\S+)\.tar\.gz debian uupdate

## keepassxc 2.3.1%2Bdfsg.1

=== src/autotype/windows/CMakeLists.txt ===
set(autotype_win_SOURCES
    AutoTypeWindows.cpp
)

add_library(keepassx-autotype-windows MODULE ${autotype_win_SOURCES})
target_link_libraries(keepassx-autotype-windows keepassx_core ${autotype_LIB} Qt5::Core Qt5::Widgets)
install(TARGETS keepassx-autotype-windows
        BUNDLE DESTINATION . COMPONENT Runtime
LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR} COMPONENT Runtime)

=== debian/changelog ===
keepassxc (2.3.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Build with all features
  * Run wrap-and-sort
  * Build-Depend on libsodium-dev, libargon2-0-dev, libcurl4-gnutls-dev
  * d/p/0002-*zxcvbn*.patch: Drop, Merged upstream
  * d/control: Point Vcs-Git and Vcs-Browser to salsa
  * d/control: Bump Standards-Version to 4.1.3

 -- Julian Andres Klode <jak@debian.org>  Sat, 10 Mar 2018 17:59:54 +0100

keepassxc (2.2.4+dfsg.1-1) unstable; urgency=medium

  * debian/watch: Drop uupdate
  * New upstream version 2.2.4+dfsg.1
    - Fixes AppStream metadata

 -- Julian Andres Klode <jak@debian.org>  Fri, 15 Dec 2017 13:19:23 +0100

keepassxc (2.2.3+dfsg.1-1) unstable; urgency=medium

  * Repack upstream tarball to remove src/zxcvbn.
    The file src/zxcvbn/dict-src.h has no source code, and the embedded
    copy is unused anway.
  * Update watch and signing-key to point to KeePassXC
  * New upstream version 2.2.3+dfsg.1
    - Fixes 16x16 message-close icon

 -- Julian Andres Klode <jak@debian.org>  Tue, 12 Dec 2017 13:07:49 +0100

keepassxc (2.2.2-1) unstable; urgency=medium

  * New upstream version 2.2.2
  * Add missing dependency on qttools5-dev (Closes: #882306)
  * Drop desktop_file_comment.patch and rebase others
  * Bump Standards-Version to 4.1.1

 -- Julian Andres Klode <jak@debian.org>  Tue, 21 Nov 2017 11:12:12 +0100

keepassxc (2.2.0-1) unstable; urgency=medium

  * Initial KeePassXC upstream version 2.2.0 (Closes: #855173)
  * Packaging changes since keepassx 2.0.3-1:
    - debian: Switch to keepassxc and Qt5
    - Enable HTTP and YubiKey features
    - desktop_file_comment.patch: Refresh using gbp pq
    - Bump Standards-Version and use debhelper 10
    - debian/control: Update maintainer
    - Use system zxcvbn.
      Thanks to Gianfranco Costamagna for providing the patch
    - Depend on libqt5x11extras5-dev
    - Turn on hardening
    - debian/copyright: Update
    - export LC_ALL=C.UTF-8 in debian/rules

 -- Julian Andres Klode <jak@debian.org>  Sat, 23 Sep 2017 21:24:46 +0200

keepassx (2.0.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #845163)
  * Add missing Comment section to the desktop file. (Closes: #846274)
    - desktop_file_comment.patch

 -- Felix Geyer <fgeyer@debian.org>  Tue, 10 Jan 2017 22:33:14 +0100

keepassx (2.0.2-1) unstable; urgency=medium

  * New upstream release. (Closes: #813608)
  * d/control: Point Vcs-* to the new git repo.
  * Update watch file.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 04 Feb 2016 21:47:37 +0100

keepassx (2.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #707634)
    - Completely rewritten compared to 0.x series
      (closes: #707634, #685533, #714357, #763083, #791858)
    - pronouncable password generator has been dropped (closes: #645499)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 09 Jan 2016 19:24:30 -0500

keepassx (2.0~beta2-1) experimental; urgency=medium

  * New upstream beta release.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 11 Sep 2015 23:55:20 +0200

keepassx (2.0~beta1-1) experimental; urgency=medium

  * New upstream beta release.
  * Update copyright file.
  * Bump Standards-Version to 3.9.6, no changes needed.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 19 Jul 2015 20:49:14 +0200

keepassx (2.0~alpha6-1) experimental; urgency=medium

  * New upstream alpha release.
    - Supports the .kdbx (KeePass 2) file format.
  * Drop fix_ftbfs_gcc47.diff, not needed anymore.
  * Switch debian/rules to use cmake and run unit tests.
  * Redo debian/copyright.
  * Update watch file.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 15 Aug 2014 00:00:01 +0200

keepassx (0.4.3+dfsg-0.1) unstable; urgency=high

  * Non-maintainer upload.
  * Use repackaged upstream tarball by Felix Geyer, which replaces icons of
    unknown origin (clientic.png text_block.png text_bold.png text_center.png
    text_italic.png text_left.png text_right.png text_under.png) and adds full
    text of associated licenses (LICENSE.LGPL-2.1 LICENSE.LGPL-3).
  * Use patch by Felix Geyer to update debian/copyright with the origin and
    license of png files, and update README.source accordingly.
  * Additionally, update debian/copyright to document the origin and copyright
    of go-*.png and help_about.png icons (project Oxygen, and license CC-BY-SA
    3.0 or LGPL respectively).
  * The above three items close #698832
  * Update debian/watch for version mangling.
  * Setting high urgency due to RC bug.

 -- Serafeim Zanikolas <sez@debian.org>  Wed, 20 Mar 2013 14:04:39 +0100

keepassx (0.4.3-2) unstable; urgency=low

  * Fix FTBFS with gcc 4.7. (Closes: #667224)
    - Add fix_ftbfs_gcc47.diff
  * Bump Standards-Version to 3.9.3, no changes needed.
  * Enable parallel building.
  * Switch to debhelper compat level v9.
    - Exports build flags.
  * Use the qmake_qt4 dh buildsystem.
  * Install application icon in various resolutions.
    - Add debian/keepassx.svg
    - Build-depend on imagemagick and librsvg2-bin.

 -- Felix Geyer <debfx-pkg@fobos.de>  Thu, 05 Apr 2012 13:10:22 +0200

keepassx (0.4.3-1) unstable; urgency=low

  * New upstream release. (Closes: #572614)
    - Fixes FTBFS with binutils-gold. (Closes: #554982)
  * Switch to new source format 3.0 (quilt).
  * Bump Standards-Version to 3.8.4, no changes needed.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sun, 07 Mar 2010 00:42:51 +0100

keepassx (0.4.1-1) unstable; urgency=low

  * New upstream release. (LP: #431798)
  * Bump debhelper to dh 7.
    - increase debian/compat to 7.
    - simplify debian/rules.
  * Bump Standards-Version to 3.8.3, no changes needed.

 -- Felix Geyer <debfx-pkg@fobos.de>  Thu, 17 Sep 2009 15:21:00 +0200

keepassx (0.4.0-1) unstable; urgency=low

  * New upstream release. (Closes: #522488)
  * adapt debian/watch file to new upstream naming style.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 04 Apr 2009 11:39:24 +0200

keepassx (0.3.4-2) unstable; urgency=low

  [ Felix Geyer ]
  * introduce quilt
